void ComputeNeighbours(int rank, int x_subdoms, int y_subdoms,
                       int *left_neighbour, int *right_neighbour,
                       int *lower_neighbour, int *upper_neighbour)

{
  if ((rank % x_subdoms) == 0)
    *left_neighbour = -1;
  else 
    *left_neighbour = rank-1;

  if ((rank % x_subdoms) == x_subdoms -1)
    *right_neighbour = -1;
  else 
    *right_neighbour = rank+1;

  if (rank < x_subdoms)
    *lower_neighbour = -1;
  else
    *lower_neighbour = rank - x_subdoms;

  if (rank >   x_subdoms*(y_subdoms-1) -1)
    *upper_neighbour = -1;
  else
    *upper_neighbour = rank + x_subdoms;

  return;
}
